<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabecComprasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabecComprasERP
 * @subpackage Arrays
 */
class ArrayOfCabecComprasERP extends AbstractStructArrayBase
{
    /**
     * The CabecComprasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecComprasERP[]
     */
    public $CabecComprasERP;
    /**
     * Constructor method for ArrayOfCabecComprasERP
     * @uses ArrayOfCabecComprasERP::setCabecComprasERP()
     * @param \StructType\CabecComprasERP[] $cabecComprasERP
     */
    public function __construct(array $cabecComprasERP = array())
    {
        $this
            ->setCabecComprasERP($cabecComprasERP);
    }
    /**
     * Get CabecComprasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecComprasERP[]|null
     */
    public function getCabecComprasERP()
    {
        return isset($this->CabecComprasERP) ? $this->CabecComprasERP : null;
    }
    /**
     * Set CabecComprasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabecComprasERP[] $cabecComprasERP
     * @return \ArrayType\ArrayOfCabecComprasERP
     */
    public function setCabecComprasERP(array $cabecComprasERP = array())
    {
        foreach ($cabecComprasERP as $arrayOfCabecComprasERPCabecComprasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabecComprasERPCabecComprasERPItem instanceof \StructType\CabecComprasERP) {
                throw new \InvalidArgumentException(sprintf('The CabecComprasERP property can only contain items of \StructType\CabecComprasERP, "%s" given', is_object($arrayOfCabecComprasERPCabecComprasERPItem) ? get_class($arrayOfCabecComprasERPCabecComprasERPItem) : gettype($arrayOfCabecComprasERPCabecComprasERPItem)), __LINE__);
            }
        }
        if (is_null($cabecComprasERP) || (is_array($cabecComprasERP) && empty($cabecComprasERP))) {
            unset($this->CabecComprasERP);
        } else {
            $this->CabecComprasERP = $cabecComprasERP;
        }
        return $this;
    }
    /**
     * Add item to CabecComprasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CabecComprasERP $item
     * @return \ArrayType\ArrayOfCabecComprasERP
     */
    public function addToCabecComprasERP(\StructType\CabecComprasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabecComprasERP) {
            throw new \InvalidArgumentException(sprintf('The CabecComprasERP property can only contain items of \StructType\CabecComprasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabecComprasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabecComprasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabecComprasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabecComprasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabecComprasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabecComprasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabecComprasERP
     */
    public function getAttributeName()
    {
        return 'CabecComprasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabecComprasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
